'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports.mergeStyles = mergeStyles;
exports.applyStyle = applyStyle;
exports.parseStyle = parseStyle;
exports['default'] = Styling;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function changeStyleCase(prop) {
  var property = prop;
  switch (prop) {
    case 'backgroundColor':
      property = 'background-color';
      break;
    case 'backgroundImage':
      property = 'background-image';
      break;
    case 'borderColor':
      property = 'border-color';
      break;
    case 'borderTopColor':
      property = 'border-top-color';
      break;
    case 'borderBottomColor':
      property = 'border-bottom-color';
      break;
    case 'borderLeftColor':
      property = 'border-left-color';
      break;
    case 'borderRightColor':
      property = 'border-right-color';
      break;
    case 'boxShadow':
      property = 'box-shadow';
      break;
  }
  return property;
}

function addStyle(selector, styles) {
  selector = selector.replace(/:placeholder/, '::-webkit-input-placeholder');

  var head = document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  var stylesheet = selector + ' {\n';

  if (typeof styles === 'string') {
    stylesheet += styles;
  } else {
    for (var prop in styles) {
      if (styles.hasOwnProperty(prop)) {
        var property = changeStyleCase(prop);
        stylesheet += '  ' + property + ': ' + styles[prop] + ' !important;\n';
      }
    }
  }

  stylesheet += '}\n';

  style.type = 'text/css';
  style.appendChild(document.createTextNode(stylesheet));
  head.appendChild(style);
  return style;
}

function mergeStyles() {
  var merged = {};
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _len = arguments.length, styles = Array(_len), _key = 0; _key < _len; _key++) {
      styles[_key] = arguments[_key];
    }

    for (var _iterator = styles[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var style = _step.value;

      merged = Object.assign(merged, style);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator['return']) {
        _iterator['return']();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return merged;
}

function applyStyle(merged) {
  var styles = {};
  for (var prop in merged) {
    if (merged.hasOwnProperty(prop) && typeof merged[prop] !== 'object') {
      styles[prop] = merged[prop];
    }
  }
  return styles;
}

function parseStyle(styles) {
  var style = '';
  for (var prop in styles) {
    if (styles.hasOwnProperty(prop) && typeof styles[prop] !== 'object') {
      style += changeStyleCase(prop) + ': ' + styles[prop] + '; ';
    }
  }
  return style;
}

function Styling(ComposedComponent) {
  return (function (_Component) {
    _inherits(_class, _Component);

    function _class() {
      _classCallCheck(this, _class);

      _get(Object.getPrototypeOf(_class.prototype), 'constructor', this).apply(this, arguments);

      this.stylesheets = [];
    }

    _createClass(_class, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var states = [':hover', ':active', ':focus', ':placeholder'];
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = states[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var state = _step2.value;

            if (this.refs.component.styles[state]) {
              var element = _reactDom2['default'].findDOMNode(this);
              var id = element.getAttribute('data-reactid');
              this.stylesheets = [].concat(_toConsumableArray(this.stylesheets), [addStyle('[data-reactid="' + id + '"]' + state, this.refs.component.styles[state])]);
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2['return']) {
              _iterator2['return']();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        if (this.refs.component.refs.element) {
          var element = _reactDom2['default'].findDOMNode(this.refs.component.refs.element);
          var activeStyle = element.getAttribute('data-active-style');
          var id = element.getAttribute('data-reactid');
          if (activeStyle) {
            this.stylesheets = [].concat(_toConsumableArray(this.stylesheets), [addStyle('[data-reactid="' + id + '"]:active', activeStyle)]);
          }
        }
      }
    }, {
      key: 'componentWillUpdate',
      value: function componentWillUpdate(nextProps, nextState) {
        if (nextState) {
          this.refs.component.setState(nextState);
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = this.stylesheets[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var element = _step3.value;

            element.parentNode.removeChild(element);
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3['return']) {
              _iterator3['return']();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2['default'].createElement(ComposedComponent, _extends({ ref: 'component' }, this.props));
      }
    }]);

    return _class;
  })(_react.Component);
}