'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _WindowState = require('./WindowState');

var _WindowState2 = _interopRequireDefault(_WindowState);

var _Styling = require('./Styling');

var _Styling2 = _interopRequireDefault(_Styling);

var _TitleBarControls = require('./TitleBar/Controls');

var _TitleBarControls2 = _interopRequireDefault(_TitleBarControls);

var styles = {
  osx_10_11: {
    WebkitUserSelect: 'none',
    cursor: 'default',
    display: 'flex',
    alignItems: 'center',
    height: '20px',
    backgroundImage: '-webkit-linear-gradient(top, #ededed 0, #ededed 1px, #e7e7e7 2px, #d1d1d1 100%)',
    borderBottomWidth: '1px',
    borderBottomStyle: 'solid',
    borderBottomColor: '#afafaf',
    borderTopWidth: '1px',
    borderTopStyle: 'solid',
    borderTopColor: '#f6f6f6',
    borderTopLeftRadius: '5px',
    borderTopRightRadius: '5px',
    paddingLeft: '3px',
    paddingRight: '3px',

    unfocused: {
      backgroundImage: '-webkit-linear-gradient(top, #f8f8f8 0px, #f8f8f8 2px, #f6f6f6 100%)',
      borderBottomColor: '#cecece'
    },

    toolbar: {
      height: '36px',
      paddingLeft: '9px',
      paddingRight: '9px'
    },

    title: {
      WebkitUserSelect: 'none',
      cursor: 'default',
      fontFamily: '"San Francisco", "Helvetica Neue", "Lucida Grande"',
      fontSize: '13px',
      color: '#676767',
      flex: 1,
      textAlign: 'center',
      lineHeight: '21px',

      unfocused: {
        color: '#b8b8b8'
      }
    }
  }
};

var TitleBar = (function (_Component) {
  _inherits(TitleBar, _Component);

  _createClass(TitleBar, null, [{
    key: 'propTypes',
    value: {
      children: _react.PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.element, _react2['default'].PropTypes.array]),
      style: _react.PropTypes.object,
      title: _react.PropTypes.string,
      controls: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function TitleBar() {
    _classCallCheck(this, _TitleBar);

    _get(Object.getPrototypeOf(_TitleBar.prototype), 'constructor', this).call(this);
    this.state = { windowFocused: true };
  }

  _createClass(TitleBar, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var controls = _props.controls;
      var title = _props.title;

      var props = _objectWithoutProperties(_props, ['children', 'controls', 'title']);

      var styles = this.styles;
      if (children) {
        styles = (0, _Styling.mergeStyles)(styles, this.styles.toolbar);
      }

      var titleStyle = this.styles.title;
      if (this.props.controls) {
        titleStyle = Object.assign(titleStyle, { paddingRight: '60px' });
      }

      if (!this.state.windowFocused) {
        styles = (0, _Styling.mergeStyles)(styles, this.styles.unfocused);
        titleStyle = (0, _Styling.mergeStyles)(titleStyle, this.styles.title.unfocused);
      }

      controls = !controls || _react2['default'].createElement(_TitleBarControls2['default'], null);
      title = !title || _react2['default'].createElement(
        'div',
        { style: titleStyle },
        this.props.title
      );

      return _react2['default'].createElement(
        'div',
        _extends({
          ref: 'element'
        }, props, {
          style: (0, _Styling.applyStyle)(styles)
        }),
        controls,
        title,
        children
      );
    }
  }, {
    key: 'styles',
    get: function get() {
      return (0, _Styling.mergeStyles)(styles.osx_10_11, this.props.style);
    }
  }]);

  var _TitleBar = TitleBar;
  TitleBar = (0, _Styling2['default'])(TitleBar) || TitleBar;
  TitleBar = (0, _WindowState2['default'])(TitleBar) || TitleBar;
  return TitleBar;
})(_react.Component);

exports['default'] = TitleBar;
module.exports = exports['default'];